"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var TabComponent = /** @class */ (function () {
    function TabComponent(resolver, router) {
        this.resolver = resolver;
        this.router = router;
        this.tabChangeEvent = new core_1.EventEmitter();
    }
    Object.defineProperty(TabComponent.prototype, "tabDatas", {
        get: function () {
            return this._tabDatas;
        },
        set: function (v) {
            this._tabDatas = v;
            this.init();
        },
        enumerable: true,
        configurable: true
    });
    TabComponent.prototype.ngOnInit = function () {
    };
    TabComponent.prototype.init = function () {
        if (this.tabDatas == null && this.tabDatas.length == 0) {
            this.dyComponent.clear();
            return;
        }
        this.dyComponent.clear();
        for (var _i = 0, _a = this.tabDatas; _i < _a.length; _i++) {
            var tab = _a[_i];
            if (tab.select) {
                this.nowSelectTab = tab;
            }
        }
        if (this.nowSelectTab == null) {
            this.nowSelectTab = this.tabDatas[0];
        }
        if (this.nowSelectTab.component) {
            var component = this.resolver.resolveComponentFactory(this.nowSelectTab.component);
            this.ref = this.dyComponent.createComponent(component);
            if (this.nowSelectTab.data) {
                var instance = this.ref.instance;
                instance.data = this.nowSelectTab.data;
            }
        }
        if (this.nowSelectTab.url) {
            var params = this.nowSelectTab.params == null ? {} : this.nowSelectTab.params;
            this.router.navigate([this.nowSelectTab.url], { queryParams: params });
        }
    };
    /*  ngOnChanges(changes: SimpleChanges) {
        if (changes.tabDatas && !changes.tabDatas.firstChange) {
          this.init();
        }
      }*/
    TabComponent.prototype.changeTab = function (tab) {
        for (var _i = 0, _a = this.tabDatas; _i < _a.length; _i++) {
            var d = _a[_i];
            d.select = false;
        }
        tab.select = true;
        this.nowSelectTab = tab;
        this.init();
        this.tabChangeEvent.emit(tab);
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object),
        __metadata("design:paramtypes", [Object])
    ], TabComponent.prototype, "tabDatas", null);
    __decorate([
        core_1.Output(),
        __metadata("design:type", Object)
    ], TabComponent.prototype, "tabChangeEvent", void 0);
    __decorate([
        core_1.ViewChild('dyComponent', { read: core_1.ViewContainerRef }),
        __metadata("design:type", core_1.ViewContainerRef)
    ], TabComponent.prototype, "dyComponent", void 0);
    TabComponent = __decorate([
        core_1.Component({
            selector: 'dc-tab',
            template: "\n  <div class=\"display-flex width-100 flex-direction-column\">\n    <div class=\"display-flex width-100\">\n        <div *ngFor=\"let d of tabDatas\">\n            <div class=\"title\" (click)=\"changeTab(d)\" [ngClass]=\"{'active':d.select}\">{{d.title}}</div>\n        </div>\n    </div>\n    <div #dyComponent class=\"width-100\"></div>\n</div>\n\n  ",
            styles: [
                '.title.active{' +
                    'color: red}',
                '.title{' +
                    'cursor: pointer;}'
            ]
        }),
        __metadata("design:paramtypes", [core_1.ComponentFactoryResolver, router_1.Router])
    ], TabComponent);
    return TabComponent;
}());
exports.TabComponent = TabComponent;
//# sourceMappingURL=tab.component.js.map