"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var TableComponent = /** @class */ (function () {
    function TableComponent(router) {
        this.router = router;
        this.checkBox = false;
        this.sortEvent = new core_1.EventEmitter();
        this.checkEvent = new core_1.EventEmitter();
        this.nowSort = {};
        this.allSelect = false;
        this.checks = [];
        this.checks_data = [];
        this.showFilter = [];
    }
    Object.defineProperty(TableComponent.prototype, "datas", {
        get: function () {
            return this._datas;
        },
        set: function (v) {
            this.allSelect = false;
            this._datas = v;
            this.initCheck();
        },
        enumerable: true,
        configurable: true
    });
    TableComponent.prototype.ngOnInit = function () {
        // this.initCheck();
    };
    TableComponent.prototype.initCheck = function () {
        this.checks = [];
        for (var _i = 0, _a = this.datas; _i < _a.length; _i++) {
            var d = _a[_i];
            this.checks.push(false);
        }
    };
    TableComponent.prototype.ngAfterContentInit = function () {
    };
    /*
      ngOnChanges(changes: SimpleChanges): void {
        if (changes.datas && !changes.datas.firstChange) {
          this.allSelect = false;
          this.datas = changes.datas.currentValue;
          this.initCheck();
        }
      }*/
    TableComponent.prototype.allSelectCheck = function () {
        this.checks = [];
        for (var _i = 0, _a = this.datas; _i < _a.length; _i++) {
            var d = _a[_i];
            this.checks.push(this.allSelect);
        }
        this.sendCheckEvent();
    };
    TableComponent.prototype.checkSelect = function () {
        var allTrue = true;
        for (var _i = 0, _a = this.checks; _i < _a.length; _i++) {
            var c = _a[_i];
            if (!c) {
                allTrue = false;
            }
        }
        if (allTrue) {
            this.allSelect = true;
        }
        else {
            this.allSelect = false;
        }
        this.sendCheckEvent();
    };
    TableComponent.prototype.sendCheckEvent = function () {
        this.checks_data = [];
        for (var i = 0; i < this.datas.length; i++) {
            if (this.checks[i]) {
                this.checks_data.push(this.datas[i]);
            }
        }
        this.checkEvent.emit(this.checks_data);
    };
    TableComponent.prototype.sort = function (header) {
        if (!header.canSort) {
            return;
        }
        if (this.nowSort.field == header.field) {
            if (this.nowSort.sort == 'asc') {
                this.nowSort.sort = 'desc';
            }
            else {
                this.nowSort.sort = 'asc';
            }
        }
        else {
            this.nowSort.field = header.field;
            this.nowSort.sort = 'desc';
        }
        if (this.sortEvent) {
            this.sortEvent.emit(this.nowSort);
        }
    };
    TableComponent.prototype.showFilterBox = function (event) {
        event.stopPropagation();
        event.preventDefault();
        var filterBoxDom = event.target.nextElementSibling;
        filterBoxDom.style.display = 'block';
        this.showFilter.push(filterBoxDom);
    };
    TableComponent.prototype.clickFilter = function (event, header) {
        header.filter.fn(event.target.value);
        var filterBoxDom = event.target.parentNode.parentNode;
        filterBoxDom.style.display = 'none';
    };
    TableComponent.prototype.onDocumentClick = function ($event) {
        for (var i = 0; i < this.showFilter.length; i++) {
        }
    };
    __decorate([
        core_1.ContentChild(core_1.TemplateRef),
        __metadata("design:type", core_1.TemplateRef)
    ], TableComponent.prototype, "template", void 0);
    __decorate([
        core_1.ViewChild('filterTemplate'),
        __metadata("design:type", Object)
    ], TableComponent.prototype, "filterTemplate", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Array)
    ], TableComponent.prototype, "headers", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Object),
        __metadata("design:paramtypes", [Object])
    ], TableComponent.prototype, "datas", null);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Boolean)
    ], TableComponent.prototype, "checkBox", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], TableComponent.prototype, "sortEvent", void 0);
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], TableComponent.prototype, "checkEvent", void 0);
    __decorate([
        core_1.HostListener('document:click', ['$event']),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", void 0)
    ], TableComponent.prototype, "onDocumentClick", null);
    TableComponent = __decorate([
        core_1.Component({
            selector: 'dc-table',
            template: "\n  <ng-template #filterTemplate let-header>\n  <div *ngIf=\"header.filter.type == 'text'\" class=\"filter-box\">\n    <p>\u8FC7\u6EE4:</p>\n    <p><input type=\"text\" value=\"\" (keyup.enter)=\"clickFilter($event, header)\"></p>\n  </div>\n</ng-template>\n<table class=\"table\">\n  <thead>\n  <tr>\n    <th *ngIf=\"checkBox\">\n      <input type='checkbox' [(ngModel)]='allSelect' (ngModelChange)=\"allSelectCheck()\">\n    </th>\n    <th class=\"table-title\" [style.width]=\"header.width\" *ngFor=\"let header of headers\" title=\"{{header.title}}\">\n      <div class=\"table-title-th text-over-flow\">\n        <div style=\"flex: 1;\"[ngClass]=\"{canSort:header.canSort}\">\n        {{header.title}}\n          <div\n            [ngClass]=\"{'sort': (!nowSort.field && header.canSort) ||(nowSort.field==header.field && nowSort.sort=='asc'),\n            'sort-desc':(nowSort.field==header.field && nowSort.sort=='desc')}\" (click)=\"sort(header)\">\n          </div>\n        </div>\n        <div *ngIf=\"header.filter\" class=\"table-th-filter\">\n          <i (click)=\"showFilterBox($event)\">\u8FC7\u6EE4</i>\n          <ng-container [ngTemplateOutlet]=\"filterTemplate\" [ngTemplateOutletContext]=\"{\n            $implicit: header\n          }\"></ng-container>\n        </div>\n      </div>\n    </th>\n  </tr>\n  </thead>\n\n  <tbody>\n  <tr *ngFor=\"let data of datas let i = index\">\n    <td *ngIf=\"checkBox\">\n      <input type='checkbox' [(ngModel)]='checks[i]' (ngModelChange)=\"checkSelect()\">\n    </td>\n    <td *ngFor=\"let header of headers\">\n      <ng-container [ngTemplateOutlet]=\"template\" [ngTemplateOutletContext]=\"{\n                    $implicit: {\n                      d: data,\n                      h: header\n                    }}\"></ng-container>\n    </td>\n  </tr>\n  </tbody>\n</table>\n  ",
            styles: [
                '.canSort {' +
                    'cursor: pointer}',
                '.table-title {' +
                    'font-size: 14px;}',
                'table {' +
                    'border: none;}',
                'table th {' +
                    'background-color: #fff;' +
                    'border-bottom: 1px solid #cccccc;}',
                'table td {' +
                    'border-bottom: 1px solid #e2e2e2;' +
                    'border-top: none;}',
                '.sort {' +
                    'background-image: url(/assets/img/sort.png);' +
                    'background-repeat: no-repeat;' +
                    'background-position: center;' +
                    'width: 20px;' +
                    'height: 13px;' +
                    'display: inline-block;}',
                '.sort-desc {' +
                    'background-image: url(/assets/img/sort.png);' +
                    'background-repeat: no-repeat;' +
                    'background-position: center;' +
                    'width: 20px;' +
                    'height: 13px;' +
                    'transform: rotate(180deg);}',
                '.table-title-th {' +
                    'display: flex;' +
                    'text-align: center;' +
                    /*justify-content: center;*/
                    'line-height: 15px;}' +
                    '.table {' +
                    'font-size: 12px;' +
                    'color: #666666 !important;' +
                    '}',
                '.table th {' +
                    'font-size: 14px;' +
                    'color: #333333 !important;' +
                    '}',
                'table-th-filter{' +
                    'position: relative;' +
                    '}',
                '.filter-box {' +
                    'position: absolute;' +
                    'display: none;' +
                    'background: #fff;' +
                    'border: 1px solid #ccc;' +
                    'border-radius: 3px;' +
                    'margin-top: 5px;' +
                    'padding-bottom: 5px;' +
                    '}',
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router])
    ], TableComponent);
    return TableComponent;
}());
exports.TableComponent = TableComponent;
//# sourceMappingURL=table.component.js.map